Bug 134497 - rpm obsoletes not functioning
Summary: rpm obsoletes not functioning
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: rpm (Show other bugs)
(Show other bugs)
Version: 2
Hardware: All Linux
medium
medium
Target Milestone: ---
Assignee: Paul Nasrat
QA Contact: Mike McLean
URL: http://linux.duke.edu/~skvidal/broken/
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2004-10-04 02:55 UTC by Seth Vidal
Modified: 2007-11-30 22:10 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-04-19 18:47:10 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
working obsoletes rpm -Uvvh output from rhl9 (5.92 KB, text/plain)
2004-10-04 14:40 UTC, Seth Vidal
no flags Details
broken obsolete rpm -Uvvh output from fc2 (5.19 KB, text/plain)
2004-10-04 14:41 UTC, Seth Vidal
no flags Details

Description Seth Vidal 2004-10-04 02:55:36 UTC
Description of problem:
rpm is not obsoleting packages.

Version-Release number of selected component (if applicable):
rpm-4.3.1-0.3

How reproducible:
every time.



Steps to Reproduce:
1. Download i686 rpms from http://linux.duke.edu/~skvidal/broken/
2. rpm -ivh baz-0.1-1.i686.rpm
3. rpm -q baz
4. rpm -qp --obsoletes quux-0.1-1.i686.rpm
5. you'll note it obsoletes baz >= 0.1
6. rpm -Uvh quux-0.1-1.i686.rpm
7. rpm -q quux - it's installed
8. rpm -q baz - it's still installed too!

Actual results:
baz is still installed

Expected results:
baz should have been removed.


Additional info:
This gets EXTRA special wacky when you start dealing with biarch since
obsoletes do not specify arch. Also consider i686 being obsoleted by
noarch.

Comment 1 Seth Vidal 2004-10-04 05:33:03 UTC
with these packages it appears to occur on fc1 and el3u3

Comment 2 Seth Vidal 2004-10-04 14:33:37 UTC
just tested on rhl9 - everything works there.

Comment 3 Seth Vidal 2004-10-04 14:40:21 UTC
Created attachment 104715 [details]
working obsoletes rpm -Uvvh output from rhl9

Comment 4 Seth Vidal 2004-10-04 14:41:30 UTC
Created attachment 104716 [details]
broken obsolete rpm -Uvvh output from fc2

Comment 5 Seth Vidal 2004-10-04 14:57:10 UTC
looks like if the version of the obsoleting package is not <= then it
will work correctly.

but if obspackage-evr is <=  installedpackage-evr then it won't remove
the other.



Comment 6 Paul Nasrat 2004-10-04 15:00:24 UTC
Relevant diff between RHL9 to HEAD, reversed on HEAD

--- depends.c   2003-03-03 22:12:00.000000000 +0000
+++ /export/anu/home/pauln/src/rpm/lib/depends.c        2004-04-01
13:56:54.000000000 +0100
@@ -305,7 +305,8 @@
             */
            if (rpmdsEVR(obsoletes) == NULL
             || rpmdsAnyMatchesDep(oh, obsoletes, _rpmds_nopromote))
-               xx = removePackage(ts, oh, rpmdbGetIteratorOffset(mi),
pkgKey);
+               if (rpmVersionCompare(h, oh))
+                   xx = removePackage(ts, oh,
rpmdbGetIteratorOffset(mi), pkgKey);
        }
        mi = rpmdbFreeIterator(mi);
     }


Comment 7 Jeff Johnson 2004-10-04 18:00:50 UTC
The added line prevents obsoleting package with identical NEVR.

This was important bug fix for major customer (I can tell from
when the fix went in), but for the life of me, I cannot remember the
problem report. Perhaps relocated packages, perhaps multilib.

Comment 8 Seth Vidal 2004-10-04 18:02:31 UTC
it also prevents obsoleting package identical EVR, not just NEVR


Comment 9 Jeff Johnson 2004-10-05 21:08:16 UTC
Fixed (by reverting the 1 line change) in rpm-4.3.2-9.

Comment 10 David Lehman 2004-12-02 23:07:26 UTC
Can we get this fixed in RHEL-3 branch as well, please?

Comment 13 Jeremy Katz 2005-04-19 18:47:10 UTC
Closing due to inactivity.  If this issue still occurs with current releases,
please reopen and set the release in which you've encountered the problem.


Note You need to log in before you can comment on or make changes to this bug.